<?php
class sv42v_application_form_fields_field extends wv42v_action {
	private $_form = null;
	private $_field = null;
	private $_field_definition = null;
	public function __construct($application, $settings) {
		parent::__construct ( $application );
		$this->_form = $settings [0];
		$this->_field = $settings [1];
		$this->_field_definition = $this->application ()->data ( $this->_form )->field_definitions [$this->_field];
	}
	public function front_html() {
		$type = $this->_field_definition ['type'];
		foreach ( $this->_field_definition as $key => $value ) {
			$this->view->$key = $value;
		}
		//echo "<pre>";
		//var_dump ( $this->_field_definition );
		//echo "</pre>";
		$this->view->field_id = "{$this->_form}_{$this->view->field}";
		$this->view->field_name = "{$this->view->field}";
		$this->view->form_field = '';
		$render = null;
		$this->view->hidden_input = '';
		$this->view->input = '';
		$this->view->checked = '';
		$this->view->readonly = '';
		$this->view->label_type = 'question';
		$return = '';
		$general = $this->data ( $this->_form )->general;
		$views = $this->data ( $this->_form )->views;
		switch ($type) {
			case 'akismet' :
				if ($this->view->error == 1) {
					$this->view->form_field = $this->view->render_string ( $views ['responses'] ['spam'] ['phtml'] );
				}
				break;
			case 'cookie' :
				if ($general ['duration'] != 0) {
					if ($this->view->error != 0) {
						$this->view->form_field = $this->view->render_string ( $views ['responses'] ['already_submitted'] ['phtml'] );
					}
				}
				break;
			case 'wpuser' :
				$this->view->field_type = 'hidden';
				$this->view->value = $this->user ()->ID;
				$this->view->hidden_input = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->input = '';
				$this->view->label = '';
				$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				break;
			case 'formsent' :
				$this->view->field_type = 'hidden';
				$this->view->value = $this->table ()->date ();
				$this->view->readonly = ' readonly = "readonly" ';
				$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->label = '';
				//$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
				$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				break;
			case 'email' :
			case 'name' :
				$this->view->field_type = 'text';
				$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
				$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				break;
			case 'text' :
				if (empty ( $this->view->options )) {
					$this->view->field_type = 'text';
					$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
					$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
					$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				} else {
					$this->view->input = $this->render_script ( "front/field/part/select.phtml", false );
					$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
					$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				}
				break;
			case 'cc' :
				$this->view->field_type = 'hidden';
				$this->view->value = 0;
				$this->view->hidden_input = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->field_type = 'checkbox';
				$this->view->value = 1;
				if ($this->request ()->is_post ()) {
					if (isset ( $_POST [$this->view->field] ) && $_POST [$this->view->field] == 1) {
						$this->view->checked = ' checked="checked" ';
					}
				}
				$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
				$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				break;
			case 'checkbox' :
				if (empty ( $this->view->options )) {
					$this->view->field_type = 'hidden';
					$this->view->value = 0;
					$this->view->hidden_input = $this->render_script ( "front/field/part/input.phtml", false );
					$this->view->field_type = 'checkbox';
					$this->view->value = 1;
					if ($this->request ()->is_post ()) {
						if (isset ( $_POST [$this->view->field] ) && $_POST [$this->view->field] == 1) {
							$this->view->checked = ' checked="checked" ';
						}
					}
					$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
					$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
					$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				} else {
					$this->view->form_field = '';
					$this->view->field_type = 'hidden';
					$this->view->value = '';
					$this->view->hidden_input = $this->render_script ( "front/field/part/input.phtml", false );
					$this->view->input = '';
					$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
					$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
					$this->view->hidden_input = '';
					$this->view->field_type = 'checkbox';
					$cnt = 0;
					$this->view->label_type = 'option';
					foreach ( ( array ) $this->view->options as $option ) {
						$this->view->field_id = "{$this->_form}_{$this->view->field}_{$cnt}";
						$this->view->field_name = "{$this->view->field}[]";
						$this->view->value = $option;
						if ($this->request ()->is_post ()) {
							$this->view->checked = '';
							if (isset ( $_POST [$this->view->field] ) && in_array ( $option, ( array ) $_POST [$this->view->field] )) {
								$this->view->checked = ' checked="checked" ';
							}
						}
						$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
						$this->view->question = $option;
						$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
						$this->view->form_field .= $this->render_script ( "front/field/right.phtml", false );
						$cnt ++;
					}
				}
				break;
			case 'radio' :
			case 'quiz_question' :
			case 'poll_question' :
				if (empty ( $this->view->options )) {
					$this->view->field_type = 'hidden';
					$this->view->value = 0;
					$this->view->hidden_input = $this->render_script ( "front/field/part/input.phtml", false );
					$this->view->field_type = 'radio';
					$this->view->value = 1;
					if ($this->request ()->is_post ()) {
						if (isset ( $_POST [$this->view->field] ) && $_POST [$this->view->field] == 1) {
							$this->view->checked = ' checked="checked" ';
						}
					}
					$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
					$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
					$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				} else {
					$this->view->form_field = '';
					$this->view->field_type = 'hidden';
					$this->view->value = '';
					$this->view->hidden_input = $this->render_script ( "front/field/part/input.phtml", false );
					$this->view->input = '';
					$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
					$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
					$this->view->hidden_input = '';
					$this->view->field_type = 'radio';
					$this->view->label_type = 'option';
					foreach ( ( array ) $this->view->options as $option ) {
						$this->view->value = $option;
						$this->view->checked = '';
						if ($this->request ()->is_post ()) {
							if (isset ( $_POST [$this->view->field] ) && $_POST [$this->view->field] == $option) {
								$this->view->checked = ' checked="checked" ';
							}
						}
						$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
						$this->view->question = $option;
						$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
						$this->view->form_field .= $this->render_script ( "front/field/right.phtml", false );
					}
				}
				break;
			case 'number_captcha' :
				$this->view->question = @sprintf ( $this->view->question, $this->view->captcha->num1, $this->view->captcha->num2 );
				$this->view->field_type = 'hidden';
				$this->view->field_id = "{$this->_form}_{$this->view->field}_answer";
				$this->view->field_name = "{$this->view->field}[answer]";
				$this->view->value = $this->view->captcha->answer;
				$this->view->hidden_input = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->field_type = 'text';
				$this->view->field_id = "{$this->_form}_{$this->view->field}_question";
				$this->view->field_name = "{$this->view->field}[question]";
				$this->view->value = '';
				$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
				$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				break;
			case 'submit' :
				if ($general ['privacy'] == 'public' || is_user_logged_in ()) {
					$this->view->field_type = 'submit';
					$this->view->input = $this->render_script ( "front/field/part/input.phtml", false );
					$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
					$this->view->form_field = $this->render_script ( "front/field/left.phtml", false );
				} else {
					$this->view->form_field = $this->view->render_string ( $views ['responses'] ['private'] ['phtml'] );
				}
				break;
			case 'textarea' :
				$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
				$this->view->form_field = $this->render_script ( "front/field/textarea.phtml", false );
				break;
			case 'recaptcha' :
				$recaptcha = new av42v_recaptcha ( $this->application () );
				$this->view->form_field = $recaptcha->get_html ();
				break;
			case 'link' :
				$this->view->field_type = 'text';
				$value = $this->view->value;
				$this->view->label = $this->render_script ( "front/field/part/label.phtml", false );
				$this->view->field_id = "{$this->_form}_{$this->view->field}_url";
				$this->view->field_name = "{$this->view->field}[url]";
				$this->view->label_type = 'option';
				$this->view->question = 'URL';
				if(isset($value['url']))
				{
					$this->view->value = $value['url'];
				}
				else
				{
					$this->view->value = '';
				}
				$this->view->label_url = $this->render_script ( "front/field/part/label.phtml", false );
				$this->view->input_url = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->field_id = "{$this->_form}_{$this->view->field}_desc";
				$this->view->field_name = "{$this->view->field}[desc]";
				$this->view->question = 'Caption';
				if(isset($value['desc']))
				{
					$this->view->value = $value['desc'];
				}
				else
				{
					$this->view->value = '';
				}
				$this->view->label_desc = $this->render_script ( "front/field/part/label.phtml", false );
				$this->view->input_desc = $this->render_script ( "front/field/part/input.phtml", false );
				$this->view->form_field = $this->render_script ( "front/field/url.phtml", false );
				break;
			case 'new' :
				break;
		}
		if (! empty ( $this->view->form_field )) {
			$return .= $this->render_script ( "front/fieldset.phtml", false );
		}
		return $return;
	}
	public function admin_html() {
		$this->view->field_id = "{$this->_field_definition['field']}";
		$this->view->field_name = "{$this->_field_definition['field']}";
		$this->view->field_definition = $this->_field_definition;
		$return = '';
//		print "<pre>xx";
//		print_r($this->view->field_definition);
//		print "yy";
//		print_r($this->application ()->data ( $this->_form )->field_definitions);
//		print "</pre>";
		$return .= $this->render_script ( "admin/field/general.phtml", false );
		return $return;
	}
	public function email_txt() {
		$return = '';
		if ($this->_field_definition ['email'] ['include'] == 1) {
			switch ($this->_field_definition ['type']) {
				case 'checkbox' :
				case 'radio' :
					if (is_array ( $this->_field_definition ['options'] )) {
						$this->_field_definition ['value'] = implode ( ', ', ( array ) $this->_field_definition ['value'] );
					} else {
						if ($this->_field_definition ['value'] == 0) {
							$this->_field_definition ['value'] = 'no';
						} else {
							$this->_field_definition ['value'] = 'yes';
						}
					}
					$return = $this->_field_definition ['question'] . ": " . $this->_field_definition ['value'];
					break;
				case 'link' :
					$return = $this->_field_definition ['question'] . ": [" . $this->_field_definition ['value'] ['desc'] . "](" . $this->_field_definition ['value'] ['url'] . ')';
					break;
				case 'textarea' :
					$return = $this->_field_definition ['question'] . ":\n" . $this->_field_definition ['value'] . "\n";
					break;
				case 'quiz_question' :
					if ($this->_field_definition ['value'] != $this->_field_definition ['answer']) {
						$return = $this->_field_definition ['question'] . ": Wrong - " . $this->_field_definition ['value'];
					} else {
						$return = $this->_field_definition ['question'] . ": Correct - " . $this->_field_definition ['value'];
					}
					break;
				default :
					$return = $this->_field_definition ['question'] . ": " . $this->_field_definition ['value'];
			}
		}
		return $return;
	}
	public function post_html() {
		$return = '';
		if ($this->_field_definition ['post'] ['include'] == 1) {
			switch ($this->_field_definition ['type']) {
				case 'checkbox' :
				case 'radio' :
					if (is_array ( $this->_field_definition ['options'] )) {
						$this->_field_definition ['value'] = implode ( ', ', ( array ) $this->_field_definition ['value'] );
					} else {
						if ($this->_field_definition ['value'] == 0) {
							$this->_field_definition ['value'] = 'no';
						} else {
							$this->_field_definition ['value'] = 'yes';
						}
					}
					$return = $this->_field_definition ['question'] . ": " . $this->_field_definition ['value'];
					break;
				case 'link' :
					$return = $this->_field_definition ['question'] . ": <a href='" . $this->_field_definition ['value'] ['url'] . "'>" . $this->_field_definition ['value'] ['desc'] . "</a>";
					break;
				case 'textarea' :
					$return = $this->_field_definition ['question'] . ":<br/>" . $this->_field_definition ['value'] . "<br/>";
					break;
				case 'poll_question' :
					$url = $this->control_url ( $this->application ()->slug . "/{$this->_form}/1.png" );
					$return = $this->_field_definition ['question'] . ": <a href='{$url}'>" . $this->_field_definition ['value'] . "</a>";
					break;
				case 'quiz_question' :
					if ($this->_field_definition ['value'] != $this->_field_definition ['answer']) {
						$return = $this->_field_definition ['question'] . ": <span class='wrong'>xx</span> " . $this->_field_definition ['value'];
					} else {
						$return = $this->_field_definition ['question'] . ": <span class='correct'>xx</span> " . $this->_field_definition ['value'];
					}
					break;
				default :
					$return = $this->_field_definition ['question'] . ": " . $this->_field_definition ['value'];
			}
		}
		return $return;
	}
	public function results_html() {
		$return = '';
		if ($this->_field_definition ['results'] ['include'] == 1) {
			switch ($this->_field_definition ['type']) {
				case 'checkbox' :
				case 'radio' :
					if (is_array ( $this->_field_definition ['options'] )) {
						$this->_field_definition ['value'] = implode ( ', ', ( array ) $this->_field_definition ['value'] );
					} else {
						if ($this->_field_definition ['value'] == 0) {
							$this->_field_definition ['value'] = 'no';
						} else {
							$this->_field_definition ['value'] = 'yes';
						}
					}
					$return = "<label>{$this->_field_definition ['question']}</label>: " . $this->_field_definition ['value'];
					break;
				case 'link' :
					$return = "<label>{$this->_field_definition ['question']}</label>: <a href='" . $this->_field_definition ['value'] ['url'] . "'>" . $this->_field_definition ['value'] ['desc'] . "</a>";
					break;
				case 'textarea' :
					$return = "<label>{$this->_field_definition ['question']}</label><br/>" . $this->_field_definition ['value'] . "<br/>";
					break;
				case 'poll_question' :
					$url = $this->control_url ( $this->application ()->slug . "/{$this->_form}/1.png" );
					$return = "<img src='{$url}'/>";
					break;
				case 'quiz_question' :
					if ($this->_field_definition ['value'] != $this->_field_definition ['answer']) {
						$return = "<span class='wrong'>&nbsp;</span><label>{$this->_field_definition ['question']}</label>";
					
		//$return = $this->_field_definition ['question'] . ": <span class='wrong'>&nbsp;</span> " . $this->_field_definition ['value'];
					} else {
						$return = "<span class='correct'>&nbsp;</span><label>{$this->_field_definition ['question']}</label>";
					}
					if ($this->_field_definition ['value'] != $this->_field_definition ['answer']) {
						$return .= "<br/>Your Answer : " . $this->_field_definition ['answer'];
						$return .= "<br/>Correct Answer : " . $this->_field_definition ['value'];
					} else {
						$return .= "<br/>Answer : " . $this->_field_definition ['value'];
					}
					$return .= "<br/>";
					break;
				default :
					$return = "<label>{$this->_field_definition ['question']}</label>: " . $this->_field_definition ['value'];
			}
		}
		return $return;
	}
	/*
	 * <input type='hidden' name='info[form_sent]' value='<?php echo $this->info()->mysql_date();?>'/>
<input type='hidden' name='info[wp_user]' value='<?php echo $this->info()->wp_user('ID');?>'/>
	 * 
	 */
}