<?php
class sv42v_controller_controller extends wv42v_action {
	public function controller_meta() {
		$return = parent::controller_meta();
		$return['slug'] = $this->settings()->application['name'];
		return $return;
	}
	private $type=null;
	public function catchAllAction() {
		$pages = $this->get_path ( get_option ( 'home' ) );
		$count = count ( $pages );
		if ($count > 1) {
			$pi = pathinfo ( $pages [$count - 1] );
			$this->type=$this->settings()->type();
			$this->settings()->form( $pi ['filename'] );
			switch ($pi ['extension']) {
				case 'csv' :
				case 'png' :
					$table = new sv42v_table ( strtolower ( $this->type . '_' . $pi ['filename'] ) ,$this->application());
					$this->$pi ['extension'] ( $table, $pi ['filename'] );
					break;
			}
		}
		return;
	}
	private function csv($table, $page) {
		$this->send_headers ( $page);
		$data = $table->get ();
		if (count ( $data ) > 0) {
			echo implode ( ',', array_keys ( $data [0] ) ) . "\n";
		}
		foreach ( $data as $datum ) {
			echo implode ( ',', $datum ) . "\n";
		}
	}
	private function png($table, $page) {
		if($this->type=='PollMe')
		$settings = $this->settings ()->all();
		{
			$table->legacy_pollme_171($this->settings());
		}
		$graphics = $this->settings()->graphics ;
		$field_definitions = $this->settings()->field_definitions ();
		$radios = $this->settings()->field_definitions (false,false,array('radio'));
		foreach ( $radios as $radio ) {
			$details = $table->option_count ( $radio );
			$max = 0;
			if (count ( $details ->options ) >= 1) {
				$max = max ( $details ->options );
			}
			$sum = array_sum ( $details ->options );
			$values = $details ->options;
			$labels = implode ( '|', array_reverse ( array_keys ( $details ->options ) ) );
			$labels = array_keys ( $details ->options );
			$name = $details ->question;
			$height = ((count ( $details->options )) * 24) + 60;
			$qs = array ();
			$qs ['cht'] = $graphics ['type']; // chart type.
			//$qs ['cht'] = 'bhs'; // chart type.
			//$qs ['cht'] = 'bvs'; // chart type.
			//$qs ['cht'] = 'p3'; // chart type.
			//$qs ['cht'] = 'p'; // chart type.
			switch ($qs ['cht']) {
				case 'bhs' :
				case 'bvs' :
					$qs ['chbh'] = 'a'; // width , bar seperation, group speration
					switch ($qs ['cht']) {
						case 'bhs' :
							$qs ['chxt'] = "y,x"; // char axis
							$qs ['chxl'] = "0:|" . implode ( '|', array_reverse ( $labels ) ) . "|1:|{$sum} Votes"; // chart axis labels
							break;
						case 'bvs' :
							$qs ['chxt'] = "x,x"; // char axis
							$qs ['chxl'] = "0:|" . implode ( '|', array_reverse ( $labels ) ) . "|1:|{$sum} Votes"; // chart axis labels
							break;
					}
					$qs ['chm'] = "N*p0*,000000,0,,11,,e"; // not sure displays %age though
					$qs ['chxp'] = "1,50"; // chart axis postistion
					$qs ['chxr'] = "0,0,{$max}"; // chart axis range
					$qs ['chxs'] = "1,676767,11.5,0,_,676767"; //turn of x axis
					$values = $this->percent ( $values, 1, '' );
					$qs ['chds'] = "0," . max ( $values ); // chart data scale
					break;
				case 'p' :
				case 'p3' :
					$name .= ' (' . array_sum ( $values ) . ' Votes)';
					$qs ['chdl'] = implode ( '|', $this->percent ( $values ) ); // chart data
					$qs ['chl'] = implode ( '|', $labels ); // chart data
					$qs ['chxt'] = "x"; // char axis
					break;
			}
			$qs ['chtt'] = "{$name}"; // chart name
			$qs ['chd'] = "t:" . implode ( ',', $values ); // chart data
			$qs ['chco'] = str_replace ( "\n", '|', $graphics ['colors'] );
			$qs ['chs'] = $graphics ['width']."x{$height}"; // chart size
			$http = new bv42v_http ( 'http://chart.apis.google.com/chart' );
			$http->method ( 'POST' );
			$http->data ( $qs );
			$http->display ();
		}
	}
	private function percent($array, $scale = 100, $suffix = '%') {
		$sum = array_sum ( $array );
		foreach ( $array as $key => $value ) {
			if ($sum == 0) {
				$array [$key] = '0' . $suffix;
			} else {
				if ($scale == 1) {
					$array [$key] = (($value / $sum) * $scale) . $suffix;
				} else {
					$array [$key] = round ( ($value / $sum) * $scale, 0, PHP_ROUND_HALF_UP ) . $suffix;
				}
			}
		}
		return $array;
	}
	protected function get_path($root = '') {
		$page = strtolower ( $_SERVER ['HTTP_HOST'] . $_SERVER ['REQUEST_URI'] );
		$rootlen = strlen ( str_replace ( 'http://', '', $root ) );
		$page = trim ( substr ( $page, $rootlen ), '/' );
		$pages = explode ( '/', $page );
		return $pages;
	}
}