<?php
class survey_read extends wv42v_action {
	public function filter_options(&$options, $selected = null) {
		if (! is_array ( $options )) {
			return;
		}
		foreach ( $options as $key => &$option ) {
			if (isset ( $options ['disabled'] ) && $options ['disabled'] == 1) {
				unset ( $options [$key] );
			} else {
				if (! isset ( $option ['value'] )) {
					$option ['value'] = $key;
				}
				if (! isset ( $option ['text'] )) {
					$option ['text'] = $key;
				}
				if ($option ['value'] == $selected) {
					$option ['selected'] = 'selected';
				} else {
					$option ['selected'] = '';
				}
			}
		}
		usort ( $options, array ($this, 'text_sort' ) );
	}
	public function filter_checked(&$value) {
		$checked = array (true, 'true', 'checked', '1', 1 );
		if (in_array ( $value, $checked )) {
			$value = 'checked';
		} else {
			$value = '';
		}
	}
	public function quizme_read_data_collectionWPfilter($return,$form=null) {
		return $this->contactme_read_data_collectionWPfilter ( $return,$form );
	}
	public function submission_read_data_collectionWPfilter($return,$form=null) {
		return $this->contactme_read_data_collectionWPfilter ( $return ,$form);
	}
	public function surveyme_read_data_collectionWPfilter($return,$form=null) {
		return $this->contactme_read_data_collectionWPfilter ( $return ,$form);
	}
	public function pollme_read_data_collectionWPfilter($return,$form=null) {
		return $this->contactme_read_data_collectionWPfilter ( $return ,$form);
	}
	public function contactme_read_data_collectionWPfilter($return,$form=null) {
		if ($return ['table'] ['name'] == "") {
			$return ['table'] ['name'] = $this->table ( "{$this->application()->slug}_{$form}" )->name ();
		}
		if ($return ['post'] ['name'] == "") {
			$return ['post'] ['name'] = $form;
		}
		return $return;
	}
	public function quizme_read_generalWPfilter($return) {
		return $this->contactme_read_generalWPfilter ( $return );
	}
	public function submission_read_generalWPfilter($return) {
		return $this->contactme_read_generalWPfilter ( $return );
	}
	public function surveyme_read_generalWPfilter($return) {
		return $this->contactme_read_generalWPfilter ( $return );
	}
	public function pollme_read_generalWPfilter($return) {
		return $this->contactme_read_generalWPfilter ( $return );
	}
	public function contactme_read_generalWPfilter($return) {
		$this->filter_options ( $return ['options'] ['scale'], $return ['scale'] );
		$this->filter_options ( $return ['options'] ['privacy'], $return ['privacy'] );
		$this->filter_options ( $return ['options'] ['status'], $return ['status'] );
		return $return;
	}
	public function quizme_read_typesWPfilter($return) {
		return $this->contactme_read_typesWPfilter ( $return );
	}
	public function submission_read_typesWPfilter($return) {
		return $this->contactme_read_typesWPfilter ( $return );
	}
	public function surveyme_read_typesWPfilter($return) {
		return $this->contactme_read_typesWPfilter ( $return );
	}
	public function pollme_read_typesWPfilter($return) {
		return $this->contactme_read_typesWPfilter ( $return );
	}
	public function contactme_read_typesWPfilter($return) {
		foreach ( $return as $key => &$value ) {
			if ($key != '_type_base') {
				$value = bv42v_data_array::merge ( $return ["_type_base"], $value );
			}
		}
		return $return;
	}
	private function value($field_definition) {
		$field = $field_definition ['field'];
		$return = '';
		if ($this->request ()->is_post ()) {
			if (isset ( $_POST [$field] )) {
				$return = $_POST [$field];
			}
		} else {
			switch ($field_definition ['type']) {
				case 'email' :
					$return = $this->user ()->user_email;
					break;
				case 'name' :
					$return = $this->user ()->display_name;
					break;
				case 'submit' :
					$return = $field_definition ['question'];
					break;
			}
		}
		if (is_array ( $return )) {
			foreach ( $return as &$value ) {
				$value = stripslashes ( $value );
			}
			unset ( $value );
		} else {
			$return = stripslashes ( $return );
		}
		return $return;
	}
	private function error($field_definition, $field_definitions, $form) {
		$field = $field_definition ['field'];
		$return = '0';
		if (! is_admin ()) {
			if ($this->request ()->is_post ()) {
				/**
				* recaptcha has to use its own field and is manadtory anyway for skip the 
				* check for recaptcha
				**/
				if($field_definition['type']!='recaptcha')
				{
					if ($field_definition ['mandatory'] != '') {
						if (! isset ( $_POST [$field] )) {
							$return = '1';
						} else {
							if ($_POST [$field] == '') {
								$return = 1;
							}
						}
					}
				}
				if ($return == '0') {
					switch ($field_definition ['type']) {
						case 'number_captcha' :
							if ($this->captchaEncode ( $_POST [$field] ['question'] ) != $_POST [$field] ['answer']) {
								$return = 1;
							}
							break;
						case 'akismet' :
							if (null === $this->_akismet_cache) {
								$akismet = new av42v_akismet ( $this->application () );
								$data = array ();
								$name = '';
								$email = '';
								foreach ( $field_definitions as $field ) {
									switch ($field ['type']) {
										case 'name' :
											$name = $_POST [$field ['field']];
											break;
										case 'email' :
											$email = $_POST [$field ['field']];
											break;
										case 'textarea' :
											$data [] = $_POST [$field ['field']];
											break;
									}
								}
								$this->_akismet_cache = $akismet->check ( $name, $email, implode ( "\n", $data ) );
							}
							if ($this->_akismet_cache) {
								$return = 1;
							}
							break;
						case 'recaptcha' :
							if (null === $this->_recapture_cache) {
								$recaptcha = new av42v_recaptcha ( $this->application () );
								$this->_recapture_cache = $recaptcha->is_valid ( $_POST ['recaptcha_challenge_field'], $_POST ['recaptcha_response_field'] );
							}
							if (! $this->_recapture_cache) {
								$return = 1;
							}
							break;
						case 'cookie' :
							if (isset ( $_COOKIE [$this->application ()->slug . '_' . strtolower ( $form )] )) {
								$return = 1;
							}
							break;
					}
				}
			} else {
				switch ($field_definition ['type']) {
					case 'cookie' :
						if (isset ( $_COOKIE [$this->application ()->slug . '_' . strtolower ( $form )] )) {
							$return = 2;
						}
						break;
				}
			}
		}
		return $return;
	}
	private $_recapture_cache = null;
	private $_akismet_cache = null;
	private function field_name($field_definition) {
		$return = "{$field_definition['field']}";
		return $return;
	}
	private function field_id($field_definition) {
		$return = "formfield_{$field_definition['field']}";
		return $return;
	}
	protected $captcha = null;
	
	private function captcha() {
		if (null === $this->captcha) {
			$num1 = mt_rand ( 0, 10 );
			$num2 = mt_rand ( 0, 10 );
			$question = sprintf ( 'The sum of %d and %d is:', $num1, $num2 );
			$answer = $this->captchaEncode ( $num1 + $num2 );
			$this->captcha = new stdClass ();
			$this->captcha->num1 = $num1;
			$this->captcha->num2 = $num2;
			$this->captcha->answer = $answer;
		}
		return $this->captcha;
	}
	private function captchaEncode($value) {
		$salt = 'fgdksd483ujhfk85gj549guqyglhglakhg';
		return md5 ( $salt . $value );
	}
	
	public function quizme_read_field_definitionsWPfilter($return, $form = null) {
		return $this->contactme_read_field_definitionsWPfilter ( $return, $form );
	}
	public function submission_read_field_definitionsWPfilter($return, $form = null) {
		return $this->contactme_read_field_definitionsWPfilter ( $return, $form );
	}
	public function surveyme_read_field_definitionsWPfilter($return, $form = null) {
		return $this->contactme_read_field_definitionsWPfilter ( $return, $form );
	}
	public function pollme_read_field_definitionsWPfilter($return, $form = null) {
		return $this->contactme_read_field_definitionsWPfilter ( $return, $form );
	}
	public function contactme_read_field_definitionsWPfilter($return, $form = null) {
		$types = $this->application ()->data ()->types;
		foreach ( $return as $key => &$value ) {
			if (isset ( $types [$value ['type']] )) {
				$value = bv42v_data_array::merge ( $types ['_type_base'], $types [$value ['type']], $value );
				$this->filter_checked ( $value ['mandatory'] );
			} else {
				unset ( $return [$key] );
			}
		}
		//echo "<pre>";
		//var_dump ( $return );
		//echo "</pre>";
		usort ( $return, array ($this, 'field_definitions_sort' ) );
		$cnt = 1;
		foreach ( $return as &$value ) {
			$value ['field'] = $cnt ++;
		}
		unset ( $value );
		if (is_admin ()) {
			$allowed_types = $types;
			foreach ( array_keys ( $types ) as $type ) {
				if (! $this->allowed ( $type, $return, $types )) {
					unset ( $allowed_types [$type] );
				}
			}
		}
		foreach ( $return as $key => &$value ) {
			$value ['value'] = $this->value ( $value );
			$value ['error'] = $this->error ( $value, $return, $form );
			$value ['multi'] = count ( $value ['options'] );
			$value ['field_name'] = $this->field_name ( $value );
			$value ['field_id'] = $this->field_id ( $value );
			if ($value ['type'] == 'number_captcha') {
				$value ['captcha'] = $this->captcha ();
			}
			if (is_admin ()) {
				$value ['types'] = array ();
				if ($value ['allowed'] != 0 || $value ['type'] == 'new') {
					$value ['types'] = $allowed_types;
					if (! in_array ( $value ['type'], array_keys ( $allowed_types ) )) {
						$value ['types'] [$value ['type']] = $types [$value ['type']];
					}
				} else {
					$value ['types'] [$value ['type']] = $types [$value ['type']];
				}
				//				if ($this->allowed ( $value['type'], $return ) || $value ['type'] == 'new') {
				//					$value ['types'] = $types;
				////					foreach ( $value ['types'] as $tkey => $tvalue ) {
				////						if (isset ( $tvalue ['type'] )) {
				////							if (! $this->allowed ( $tvalue, $return )) {
				////								unset ( $return [$key] ['types'] [$tkey] );
				////							}
				////						}
				//					}
				//				}
				//				if (! $this->allowed ( $value['type'], $return )) {
				//					$value ['types'] [$value ['type']] = $types [$value ['type']];
				//				}
				$this->filter_options ( $value ['types'], $value ['type'] );
			} else {
				if ($value ['type'] == 'submit') {
					$value ['question'] = '';
				}
			}
		}
		return $return;
	}
	public function allowed($type, $fields, $types) {
		// no limit to the number allowed
		if ($types [$type] ['allowed'] == - 1) {
			return true;
		}
		// not allowed to apear in drop down
		if ($types [$type] ['allowed'] == 0) {
			return false;
		}
		// check that the the limit for this field
		$count = 0;
		foreach ( $fields as $cfield ) {
			if ($cfield ['type'] == $type) {
				$count ++;
			}
		}
		return ($types [$type] ['allowed'] > $count);
	}
	function field_definitions_sort($a, $b) {
		$pos_a = $a ['field'];
		$pos_b = $b ['field'];
		if (null !== $a ['fixed_field']) {
			$pos_a = $a ['fixed_field'];
		}
		if (null !== $b ['fixed_field']) {
			$pos_b = $b ['fixed_field'];
		}
		if ($pos_a == $pos_b) {
			return 0;
		}
		return ($pos_a < $pos_b) ? - 1 : 1;
	}
	function text_sort($a, $b) {
		if ($a ['text'] == $b ['text']) {
			return 0;
		}
		return ($a ['text'] < $b ['text']) ? - 1 : 1;
	}

}		